"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream = require("stream");
const decompressResponse = require("decompress-response");
const mimicResponse = require("mimic-response");
const progress_1 = require("./progress");
exports.default = (response, options, emitter) => {
    var _a;
    const downloadBodySize = Number(response.headers['content-length']) || undefined;
    const progressStream = progress_1.downloadProgress(emitter, downloadBodySize);
    mimicResponse(response, progressStream);
    const newResponse = (options.decompress &&
        options.method !== 'HEAD' ? decompressResponse(progressStream) : progressStream);
    if (!options.decompress && ['gzip', 'deflate', 'br'].includes((_a = response.headers['content-encoding'], (_a !== null && _a !== void 0 ? _a : '')))) {
        options.encoding = null;
    }
    emitter.emit('response', newResponse);
    emitter.emit('downloadProgress', {
        percent: 0,
        transferred: 0,
        total: downloadBodySize
    });
    stream.pipeline(response, progressStream, error => {
        if (error) {
            emitter.emit('error', error);
        }
    });
};
