/// <reference types="node" />
import https = require('https');
import { Options, NormalizedOptions, URLOrOptions, Defaults } from './utils/types';
export declare const preNormalizeArguments: (options: Options, defaults?: NormalizedOptions) => NormalizedOptions;
export declare const mergeOptions: (...sources: Options[]) => NormalizedOptions;
export declare const normalizeArguments: (url: URLOrOptions, options?: Options, defaults?: Defaults) => NormalizedOptions;
export declare type NormalizedRequestArguments = https.RequestOptions & {
    body: Pick<NormalizedOptions, 'body'>;
    url: Pick<NormalizedOptions, 'url'>;
};
export declare const normalizeRequestArguments: (options: NormalizedOptions) => Promise<NormalizedRequestArguments>;
